import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.omg.CORBA.Any;
import org.omg.CORBA.NVList;
import org.omg.CORBA.NamedValue;
import org.omg.CORBA.ORB;
import org.omg.CORBA.Request;

/* Annick Fron
 * Dans cet exemple le client utilise l'interface dynamique
 * et n'a pas besoin de stub
 * on pourra s'assurer que les performances sont peu affectees
 */


public class Client {
	 public static void main (String[] args) {
		 
		  ORB orb = ORB.init (args, null);
		 
		 
			   InputStream f;
			try {
				f = new FileInputStream(System.getProperty("user.home")+System.getProperty("file.separator")+"Bourse.ior");
		
			    BufferedReader reader= new BufferedReader(new InputStreamReader(f));
			    String ior;
			
					ior = reader.readLine();

					org.omg.CORBA.Object brongniart= orb.string_to_object(ior);
			 
	

					// on cree une liste d'arguments de taille 1
		   NVList argList = orb.create_list (1);
		   			// on cree un argument en entree de type String
		   Any argument = orb.create_any ();
		   argument.insert_string ("Orange");
		   argList.add_value ("societe", argument, org.omg.CORBA.ARG_IN.value);
		 
		   // On cree un objet de type double pour le resultat
		   Any result = orb.create_any ();
		   result.insert_double (0);
		   NamedValue resultVal = orb.create_named_value ("resultat", result, org.omg.CORBA.ARG_OUT.value);
		 

		   // on construit la requete et on l'invoque
		   Request thisReq = brongniart._create_request (null, "obtenirPrix", argList, resultVal);
		   thisReq.invoke ();
		 
		   // on obtient la valeur et on deplie l'argument de type double
		   result = thisReq.result().value ();
		   System.out.println ("Prix : " + result.extract_double ());
		 
			} catch (FileNotFoundException e) {
			
				e.printStackTrace();
			} catch (IOException e) {
				
				e.printStackTrace();
			} }
		
		 } 


