import java.io.DataOutputStream;
import java.io.FileOutputStream;
import java.io.OutputStream;

import org.omg.CORBA.ORB;
import org.omg.CORBA.Object;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

import PlaceMarche.Bourse;
import PlaceMarche.BourseHelper;
import PlaceMarche.BourseImpl;


public class BourseServeur {

	/**
	 * @param args
	 */
	   public static void main(String args[])
	    {
	        try{
	            
	            // Creation et initialisation de l'ORB
	            ORB orb = ORB.init(args, null);

	            // Creation de l'objet Bourse
	            BourseImpl brongniart = new BourseImpl();

	            // Activation du POAManager
	            POA rootpoa =
	              POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
	            rootpoa.the_POAManager().activate();

	            // Reference du servant
	            org.omg.CORBA.Object ref = rootpoa.servant_to_reference(brongniart);
	            Bourse href = BourseHelper.narrow(ref);
	         
	            // stockage de l'ior de l'objet distant dans un fichier
	            // dans le repertoire de l'utilisateur sous le nom Bourse.ior
	            OutputStream f = new FileOutputStream(System.getProperty("user.home")+System.getProperty("file.separator")+"Bourse.ior");
	            DataOutputStream out = new DataOutputStream(f);
	            String ior = orb.object_to_string( (Object) href);
	            out.writeBytes(ior);
	            out.close();
	 
	            System.out.println("IOR is "+ ior);
	 
	            // attente des connexions client
	            java.lang.Object sync = new java.lang.Object();
	            synchronized (sync) {
	                sync.wait();
	            }
	 
	        } catch (Exception e) {
	            System.err.println("ERROR: " + e);
	            e.printStackTrace(System.out);
	        }
	    }

}
