import java.util.Properties;

import org.omg.CORBA.ORB;
import org.omg.CORBA.ORBPackage.InvalidName;

import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;

import org.omg.CosNaming.NamingContextPackage.CannotProceed;
import org.omg.CosNaming.NamingContextPackage.NotFound;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;
import org.omg.PortableServer.POAManagerPackage.AdapterInactive;
import org.omg.PortableServer.POAPackage.ServantNotActive;
import org.omg.PortableServer.POAPackage.WrongPolicy;

import PlaceMarche.Bourse;
import PlaceMarche.BourseHelper;
import PlaceMarche.BourseImpl;

/* Annick Fron
 * Cet exemple utilise cette fois le service de noms et non plus l'IOR
 */
public class Serveur {


	public static ORB initOrb(String[] args){
		  Properties properties = System.getProperties();
	      properties.put( "org.omg.CORBA.ORBInitialHost",
	          "localhost" );
	      properties.put( "org.omg.CORBA.ORBInitialPort",
	          "1050" );
	    // Create and initialize the ORB
	    ORB orb = ORB.init(args, null);
	    return orb;
	}
	public static void main(String[] args) {
	    ORB orb=initOrb(args);

	    // Cree l'implementation distante
	    BourseImpl brongniart = new BourseImpl();

	    // Active le POAManager
	    POA rootpoa;
		try {
			rootpoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
		
	    rootpoa.the_POAManager().activate();

	    // reference sur le servant
	    org.omg.CORBA.Object ref = rootpoa.servant_to_reference(brongniart);
	    Bourse referenceBrongniart = BourseHelper.narrow(ref);

	    // Utilisation du service de noms
	    org.omg.CORBA.Object refAnnuaire =
	      orb.resolve_initial_references("NameService");
	    NamingContextExt annuaireDistant = NamingContextExtHelper.narrow(refAnnuaire);

	    // stockage de l'objet dans l'annuaire
	    String nom = "PalaisBrongniart";
/*	   NameComponent[] chemin=new NameComponent[2];
	   chemin[0]=new NameComponent("application1","");
	   chemin[1]=new NameComponent(nom,"");
	    annuaireDistant.rebind(chemin, referenceBrognard);
*/
	    annuaireDistant.rebind(annuaireDistant.to_name(nom), referenceBrongniart);
	   
	    System.out.println("Bourse prete.");
	    orb.run();
		} catch (InvalidName e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (AdapterInactive e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (org.omg.CosNaming.NamingContextPackage.InvalidName e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NotFound e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (CannotProceed e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ServantNotActive e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (WrongPolicy e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 

	}

}
