import java.util.Properties;

import org.omg.CORBA.ORB;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

import finance.Banque;
import finance.BanqueHelper;
import finance.BanqueImpl;

/* Annick Fron
 * Test de passage d'arguments
 */

public class Serveur {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Properties properties = System.getProperties();
	      properties.put( "org.omg.CORBA.ORBInitialHost",
	          "localhost" );
	      properties.put( "org.omg.CORBA.ORBInitialPort",
	          "1050" );
	    // initialisation de l'ORB
	    ORB orb = ORB.init(args, null);

	    // Create the RemoteStack implementation
	    BanqueImpl hasard = new BanqueImpl();

	    // Activate the POAManager
	    POA rootpoa;
		try {
			rootpoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
		
	    rootpoa.the_POAManager().activate();

	    // Get object reference from the servant
	    org.omg.CORBA.Object ref = rootpoa.servant_to_reference(hasard);
	    Banque referenceBanque = BanqueHelper.narrow(ref);

	    // Using NameService
	    org.omg.CORBA.Object refAnnuaire =
	      orb.resolve_initial_references("NameService");
	    NamingContextExt annuaireDistant = NamingContextExtHelper.narrow(refAnnuaire);

	    // Bind the "REMOTE_STACK" Object Reference in Naming
	    String nom = "BanqueHasard";

	    annuaireDistant.rebind(annuaireDistant.to_name(nom), referenceBanque);
	    // Server Ready
	    System.out.println("Banque prete.");
	    orb.run();

	}catch(Exception e){e.printStackTrace();}}

}
