package serveur;

import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import org.omg.CORBA.ORB;
import org.omg.CORBA.Object;
import org.omg.CORBA.ORBPackage.InvalidName;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;
import PlaceMarche.Bourse;

import PlaceMarche.BourseImpl;
import PlaceMarche.BoursePOATie;
import org.omg.PortableServer.POAManagerPackage.AdapterInactive;

public class Serveur {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		   // Creation et initialisation de l'oRB
        ORB orb = ORB.init(args, null);

        // Creation de l'objet Bourse
        BourseImpl brongniart = new BourseImpl();

        // Active le POAManager
        POA rootpoa;
		try {
			rootpoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
		
        rootpoa.the_POAManager().activate();

        // reference du servant
        BoursePOATie tie = new BoursePOATie(brongniart, rootpoa);

        // activation de l'objet
        Bourse href = tie._this(orb);
 
     
        // stockage de l'IOR
        OutputStream f = new FileOutputStream(System.getProperty("user.home")+System.getProperty("file.separator")+"Bourse.ior");
        DataOutputStream out = new DataOutputStream(f);
        String ior = orb.object_to_string( (Object) href);
        out.writeBytes(ior);
        out.close();

        System.out.println("IOR is "+ ior);

        // attente de connexions client
        java.lang.Object sync = new java.lang.Object();
        synchronized (sync) {
            sync.wait();
        }
		} catch (InvalidName e) {
		
			e.printStackTrace();
		} catch (FileNotFoundException e) {
		
			e.printStackTrace();
		} catch (InterruptedException e) {
		
			e.printStackTrace();
		} catch (IOException e) {
		
			e.printStackTrace();
		} catch (AdapterInactive e) {
			
			e.printStackTrace();
		}

	}

}
