import java.util.Properties;

import org.omg.CORBA.ORB;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

import finance.Banque;
import finance.BanqueHelper;
import finance.BanqueImpl;
/* Annick Fron
 * Cet exemple illustre le passage par valeur par value type
 */


public class Serveur {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Properties properties = System.getProperties();
	      properties.put( "org.omg.CORBA.ORBInitialHost",
	          "localhost" );
	      properties.put( "org.omg.CORBA.ORBInitialPort",
	          "1050" );
	    // Initialise l'ORB
	    ORB orb = ORB.init(args, null);

	   // l'implementation de l'objet distant
	    BanqueImpl hasard = new BanqueImpl();

	    // Active le POAManager
	    POA rootpoa;
		try {
			rootpoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
		
	    rootpoa.the_POAManager().activate();

	    // reference sur le servant
	    org.omg.CORBA.Object ref = rootpoa.servant_to_reference(hasard);
	    Banque referenceBanque = BanqueHelper.narrow(ref);

	    // Service de noms
	    org.omg.CORBA.Object refAnnuaire =
	      orb.resolve_initial_references("NameService");
	    NamingContextExt annuaireDistant = NamingContextExtHelper.narrow(refAnnuaire);

	    // Stockage dans l'annuaire
	    String nom = "BanqueHasard";

	    annuaireDistant.rebind(annuaireDistant.to_name(nom), referenceBanque);
	    // serveur pret
	    System.out.println("Banque prete.");
	    orb.run();
	}catch(Exception e) {e.printStackTrace();}

}}
