import java.util.Properties;

import org.omg.CORBA.ORB;
import org.omg.CORBA.Policy;
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;
import org.omg.PortableServer.LifespanPolicyValue;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

import PlaceMarche.BourseImpl;


public class Serveur {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
	       // Initailisation de l'ORB
		Properties properties = System.getProperties();
        properties.put( "org.omg.CORBA.ORBInitialHost",
            "localhost" );
        properties.put( "org.omg.CORBA.ORBInitialPort",
            "1050" );
        ORB orb = ORB.init(args, properties);
        try{
       

        // Creation du POA avec une politique de persistance
        // *******************  

        POA rootPOA = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));

        Policy[] persistentPolicy = new Policy[1];
        persistentPolicy[0] = rootPOA.create_lifespan_policy(
            LifespanPolicyValue.PERSISTENT);
    
        POA persistentPOA = rootPOA.create_POA("POApersistant", null, 
            persistentPolicy ); 
        // Activation du POA Manager
        persistentPOA.the_POAManager().activate( );
        // ***********************
        // Initialisation de l'objet
        BourseImpl brongniart = new BourseImpl(orb); 
        //assciation de l'objet avec le POA persistant
        persistentPOA.activate_object( brongniart );

        // Utilisation du service de noms
        org.omg.CORBA.Object obj = orb.resolve_initial_references(
            "NameService" );
        NamingContextExt rootContext = NamingContextExtHelper.narrow( obj );

        NameComponent[] nc = rootContext.to_name( 
            "PalaisBrongniart" );
        rootContext.rebind( nc, persistentPOA.servant_to_reference( 
            brongniart ) );

        // Serveur pret pour les connexions
        orb.run();
        } catch(Exception e){e.printStackTrace();}
	}

}
